#----------------------------------------------------------------------------------------------------
#David T. Ashley, 11/10/2018
#----------------------------------------------------------------------------------------------------
#This file contains everything learned from Chapter 4.
#----------------------------------------------------------------------------------------------------
import sys
import math   #Many math functions available in Python libraries.

#Math functions built in.
x = math.pi
print(x)
y = math.sqrt(x)
print(y)

#String assignment.
s = 'Now is the time for all good men to come to the aid of their country.'

#Reference to single character.
print(s[3])

#Reference to character range, called slices.  Second
#limit is < limit, i.e. open interval on the right.
print(s[3:7])

#Can use one greater on the right to get full string.
print(s[0:len(s)])

#Can use negative indices to go backwards in a string.
print(s[3:-3])

#String concatenation.
t = s+s
print(t)

#String repetition.
u = s*10
print(u)

#Strings are immutable (can't be changed in place).  Illegal assignment below:
#s[0] = 'q'
#Must instead construct new string and assign.

#list:  expands to list.
l=list(s)
print(l)

#Can omit left or right limits, in which case defaults to first and last elements.
print(s[:3])
print(s[3:])
print(s[:])

#Byte arrays.  Literals are b'chars'.  Created with bytearray().
ba=bytearray(b'spam')
ba.extend(b'eggs')
print(ba)
bad=ba.decode()
print(bad)



##
